Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0005207opensim[REGION] OpenSim Corepublic2010-11-13 05:102012-01-13 17:21
Reporterkenvc 
Assigned Tojustincc 
PrioritynormalSeveritycrashReproducibilityalways
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Versionmaster (dev code) 
Target VersionFixed in Versionmaster (dev code) 
Summary0005207: 11/09/2010 OSGrid Opensim Dev .7.1 continual crashing ("OpenSim.32BitLaunch.exe has stopped working")
DescriptionThis issue was not happening prior to the installation of the 11/09/2010 OSGrid Opensim release. Now, this issue is repeatable making the sims slow down so much that they are almost to slow to use. The computer is a quad core 2.8 ghz with 8 gig ram running 64 bit Windows 7 and using a special 32 bit launcher from Whitestar to allow the use of additional memory. Without this launcher, 64 bit windows 7 crashed repeatedly even with previous Opensim versions.

64bit Windows pops up a window saying "OpenSim.32BitLaunch.exe has stopped working", then system slows way down until the instance is forcefully closed and restarted.

The attached log file and opensim.ini file was collected specifically for the purpose of documenting this problem. It is very repeatable so it was not an issue to gather detailed information.

The sequence of events in the attached log that will make this issue happen are as follows:
1. Start up the instance. It contains 6 sims in 1 instance.
2. Avitar skin and clothes never rezz.
3. Inventory shows all the indications that it is fully loaded.
4. I tried to rename a different skin in the inventory and planned to wear it, but Imprudence immediately crashes at this point.
5. Sign back in and avitar appearance is still the same.
6. Much more lag detected now than before.
6. Inventory now says there are 5808 items but thats less than half what I have and it doesnt appear to be loading any more items.
7. Walk around a bit and Opensim starts spewing the same error over and over which you will see at the end of the log file.
8. Lag gets even worse at this point making it almost unusable.
9. Examining the Server screen shows that a window has popped up saying "OpenSim.32BitLaunch.exe has stopped working"
10. At this point I collected the attached log file and the screen shot and then logged out and restarted the instance.
Additional InformationSee attached log files, screen shot, and current opensim.ini file. I have tried many different settings in the Opensim.ini to resolve this issue and the settings in this file seems to slightly minimize the issue, but it still happens.

Don't know any way to provide any more detailed information than this.
TagsNo tags attached.
Git Revision or version numberae9c4a4d118e126b4f849bbfed112d0971459339
Run Mode Grid (Multiple Regions per Sim)
Physics EngineODE
Environment.NET / Windows64
Mono VersionNone
ViewerImprudence or Hippo
Attached Filesrar file icon Crash Log Files.rar [^] (483,644 bytes) 2010-11-13 05:10

- Relationships

-  Notes
(0017289)
WhiteStar (reporter)
2010-11-13 07:20

CLARIFYING Patching OpenSim to use LargeMemory. Here is the Documentation on the process and is well known and has been used by myself and others such as Nebadon in OSG.
----------------------------------------------------------------
Patching OpenSim.exe & OpenSim.32BitLaunch.exe to allow them to access more RAM in Windows Systems.

WHY ?
An application running in 32Bit Mode on Windows can only access access 2GB Ram Total by default. As seen with OpenSim, this
can can easily be reached when you throw in enough prims, scripts & users. The Solution is to patch the EXE to make it aware
and to adjust 32-Bit windows to accomodate that (x64 is already capable).

When a 32-bit application is Large Address Aware, it can access up to 4GB on x64 operating systems and up to 3GB on x86.
64-bit Windows, require no modifications to the operating system to benefit from the Patched EXE files.
32-bit Windows, require some adjustments and they vary according to Version of Windows.
Linux/Mono do not appear affected by Large Address Aware patched exe's *** Still needs thorough verification. ***

How-To Patch EXE

Method 1)

    If you have Visual Studio 2008/2010 and/or C++ Express
    COPY your OpenSim.exe / OpenSim.32BitLaunch.exe to a safe place (backup)
    Copy again to a separate Working Directory (the ones you will patch)
    Open a Command Prompt (CMD) and change directory to that working dir
    run Following Command: OpenSim.32BitLaunch.exe

    REFERENCE for EDITBIN
    http://msdn.microsoft.com/en-us/library/xd3shwhf.aspx [^]


Method 2) (maybe simpler and does not require C++ be installed)

    http://forums.techpowerup.com/showthread.php?t=112556 [^]
    Above has an APPLICATION in the first posting which makes patching your executables easy.
    See Thread in the link for details.


Windows Mods Required (not applicable to 64bit)

    ******************************************************************
    *** WARNING - FOLLOW THE DIRECTIONS AND BACKUP BACKUP BACKUP ! ***
    ******************************************************************

WIN-XP
    Ensure you have View All Files & System Files enabled.
    In the root of C:\ you will see a file named "boot.ini" MAKE A BACKUP COPY OF IT somewhere safe !
    Edit it with NotePad (you must be admin priviledged) and ADD the /3GB switch as shown below

    It will look similar to this example:

    [boot loader]
    timeout=30
    default=multi(0)disk(0)rdisk(0)partition(2)\WINNT
    [operating systems]
    multi(0)disk(0)rdisk(0)partition(2)\WINNT="????" /3GB

    Where: "????" in the example can be the programmatic name of the operating system versions shown below:
    Windows XP Professional / Windows Server 2003 / Windows Server 2003 Enterprise Edition / Windows Server 2003 Datacenter Edition.

    REFERENCE: http://www.microsoft.com/whdc/system/platform/server/pae/paemem.mspx [^]

WIN-VISTA
    Vista uses BCDedit. A powerful yet potentially Very dangerous tool !
    Open a Command Prompt (CMD)
    Make a New Directory to preserve a BACKUP of the System Store & change dir there.
    Example: md c:\BCDbackup then cd c:\BCDbackup
    NEXT
       run the follow command IN BCDbackup: bcdedit /export MyFileName
       Where MyFileName is something simple like MyBCD
    NEXT
       run the following command: BCDEDIT /Set INCREASEUSERVA 3072
       NOTE: That is the Maximum assuming you have that much RAM and don't even try to make it more, the result would be not pleasant.

    !! RESTORING IN CASE OF ISSUES !!
    The following command imports the data from C:\Data\BCD Backup into the system store:
    bcdedit /import "c:\BCDbackup\MyBCD"

    REFERENCE for BCDedit:
    http://download.microsoft.com/download/9/c/5/9c5b2167-8017-4bae-9fde-d599bac8184a/BCDedit_reff.docx [^]



WIN-7 (Nothing Required, support is already there and better implemented)


*** CLOSING NOTES ***
*********************
By Patching the EXE files, they will use up to 4GB Ram on 64Bit or 3GB on 32bit. This will not force
the system and won't cause harm if the the system does not have the RAM.

Modifying Win-XP & Vista (especially Vista) is a risk you have to measure for yourself. These are well documented
and known to work as you can see with the provided reference info.

Effects on Linux / Mono: None have been noted by anyone using patched EXE files as Linux Handles memory differently
but it is still subject to specific 32Bit limitations for 32Bit flavours.



Additional REFERENCE INFORMATION

    http://www.microsoft.com/whdc/system/platform/server/pae/paemem.mspx [^]
    http://support.microsoft.com/default.aspx?scid=889654 [^] (shows mem capabilities & page sizing)
    http://bilbroblog.com/wow64/hidden-secrets-of-w0w64-ndash-large-address-space/ [^]
(0017290)
kenvc (reporter)
2010-11-13 07:29

Whitestar, yes your patch is the one I am using. It significantly reduces the occurance of this issue, but it no longer eliminates this issue after installing this last OSGrid/Opensim update.
(0020588)
kenvc (reporter)
2011-12-21 09:32

This issue appears to have been related to memory consumption when avatars login to the region. The issue has significantly improved in the latest dev master although it still happens on rare occassions.

- Issue History
Date Modified Username Field Change
2010-11-13 05:10 kenvc New Issue
2010-11-13 05:10 kenvc File Added: Crash Log Files.rar
2010-11-13 05:10 kenvc Git Revision => ae9c4a4d118e126b4f849bbfed112d0971459339
2010-11-13 05:10 kenvc SVN Revision => 0
2010-11-13 05:10 kenvc Run Mode => Grid (Multiple Regions per Sim)
2010-11-13 05:10 kenvc Physics Engine => ODE
2010-11-13 05:10 kenvc Environment => .NET / Windows64
2010-11-13 05:10 kenvc Mono Version => None
2010-11-13 05:10 kenvc Viewer => Imprudence or Hippo
2010-11-13 05:11 kenvc Description Updated
2010-11-13 05:14 kenvc Description Updated
2010-11-13 05:14 kenvc Additional Information Updated
2010-11-13 05:29 kenvc Summary 11/09/2010 OSGrid .7.1 continual crashing 64 Bit Windows 7 ("OpenSim.32BitLaunch.exe has stopped working") => 11/09/2010 OSGrid Opensim Dev .7.1 continual crashing ("OpenSim.32BitLaunch.exe has stopped working")
2010-11-13 07:20 WhiteStar Note Added: 0017289
2010-11-13 07:29 kenvc Note Added: 0017290
2011-12-21 09:32 kenvc Note Added: 0020588
2011-12-21 09:32 kenvc Status new => resolved
2011-12-21 09:32 kenvc Fixed in Version => master (dev code)
2012-01-13 17:21 justincc Status resolved => closed
2012-01-13 17:21 justincc Assigned To => justincc
2012-01-13 17:21 justincc Resolution open => fixed


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker